unit UnitClientTCP;
{ Client TCP utilisant les socket de F. Piette}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WSocket;

type
  TForm1 = class(TForm)
    WSocketClient: TWSocket;
    EditServeur: TEdit;
    Label1: TLabel;
    EditPort: TEdit;
    Label2: TLabel;
    EditMessage: TEdit;
    ButtonEnvoi: TButton;
    ButtonConnect: TButton;
    ButtonDeconnect: TButton;
    Label3: TLabel;
    LabelEtat: TLabel;
    Label4: TLabel;
    LabelData: TLabel;
    procedure ButtonEnvoiClick(Sender: TObject);
    procedure ButtonConnectClick(Sender: TObject);
    procedure WSocketClientSessionConnected(Sender: TObject;
      ErrCode: Word);
    procedure ButtonDeconnectClick(Sender: TObject);
    procedure WSocketClientSessionClosed(Sender: TObject; ErrCode: Word);
    procedure WSocketClientDataAvailable(Sender: TObject; ErrCode: Word);
  private
    { Dclarations prives }
    ConnectError:Word;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ButtonEnvoiClick(Sender: TObject);
begin
if WSocketClient.State = WSConnected then
  begin
  WSocketClient.SendStr(EditMessage.Text);
  end;

end;

procedure TForm1.ButtonConnectClick(Sender: TObject);
begin
if WSocketClient.State <> wsConnected then
  begin
  WSocketClient.Proto:='tcp';
  WSocketClient.Addr:=EditServeur.Text;
  WSocketClient.Port:=EditPort.Text;
  WSocketClient.Connect;
  LabelEtat.Caption:='Attente de Connexion';
  //La demande de connexion est asynchrone (non bloquante)
  //on doit donc attendre que la session soit connecte
  //ou que l'application se termine  (test ci-dessous inutile pour un exemple simple)
  While WSocketClient.State in [WsConnecting] do
    begin
    Application.ProcessMessages;
    If Application.Terminated then
      Exit;
    end;

  end;
end;

procedure TForm1.WSocketClientSessionConnected(Sender: TObject;
  ErrCode: Word);
begin
ConnectError:=Error;
if connectError <> 0 then
  LabelEtat.Caption:='Connexion impossible'
else
  begin
  ButtonDeconnect.Enabled:=true;
  ButtonConnect.Enabled:=false;
  LabelEtat.Caption:='Connect au Serveur';
  end;  
end;

procedure TForm1.ButtonDeconnectClick(Sender: TObject);
begin
WSocketClient.Close;
end;

procedure TForm1.WSocketClientSessionClosed(Sender: TObject;
  ErrCode: Word);
begin
ButtonDeconnect.Enabled:=False;
ButtonConnect.Enabled:=true;
LabelEtat.Caption:='Dconnect';
end;

procedure TForm1.WSocketClientDataAvailable(Sender: TObject;
  ErrCode: Word);
begin
LabelData.Caption:=WSocketClient.ReceiveStr;
end;

end.
